diff --git a/tests/kms_force_connector_basic.c b/tests/kms_force_connector_basic.c
index d2c804c..e66ce62 100644
--- a/tests/kms_force_connector_basic.c
+++ b/tests/kms_force_connector_basic.c
@@ -22,6 +22,8 @@
  *
  */
 
+#define _GNU_SOURCE
+#include <stdio.h>
 #include "igt.h"
 
 IGT_TEST_DESCRIPTION("Check the debugfs force connector/edid features work"
@@ -31,6 +33,11 @@ IGT_TEST_DESCRIPTION("Check the debugfs force connector/edid features work"
 	igt_assert_eq(m.hdisplay, h); igt_assert_eq(m.vdisplay, w); \
 	igt_assert_eq(m.vrefresh, r);
 
+#define HDISPLAY_4K	3840
+#define VDISPLAY_4K	2160
+/* magic number of audio outputs when reloading the driver */
+#define AUDIO_OUTPUTS	3
+
 static void reset_connectors(void)
 {
 	int drm_fd = 0;
@@ -68,12 +75,191 @@ static int opt_handler(int opt, int opt_index, void *data)
 	return 0;
 }
 
+static int
+eld_is_valid(uint8_t no_outputs)
+{
+	FILE *in;
+	char buf[1024];
+	char *eld_path;
+	int ret;
+	uint8_t eld_valid = 0;
+	uint8_t mon_valid = 0;
+	uint8_t i;
+
+	/* 
+	 * Reloading the driver would reset the #no of outputs, so we need to
+	 * check of them.
+	 */
+	for (i = 0; i < no_outputs; i++) {
+
+		ret = asprintf(&eld_path, "/proc/asound/HDMI/eld#0.%hu", i);
+		igt_assert_neq(ret, -1);
+
+		in = fopen(eld_path, "r");
+		if (!in) {
+			igt_debug("Failed to open '%s'\n", eld_path);
+			return 0;
+		}
+
+		memset(buf, 0, 1024);
+
+		while ((fgets(buf, 1024, in)) != NULL) {
+
+			char *line = buf;
+			igt_debug("'%s'", line);
+
+			if (!strncasecmp(line, "eld_valid", 9) &&
+					strstr(line, "1")) {
+				eld_valid++;
+			}
+
+			if (!strncasecmp(line, "monitor_name", 12) &&
+					strstr(line, "IGT")) {
+				mon_valid++;
+			}
+		}
+
+		if (mon_valid && eld_valid) {
+			free(eld_path);
+			fclose(in);
+			return 1;
+		}
+
+		fclose(in);
+		free(eld_path);
+	}
+
+	return 0;
+}
+
+static void
+hdmi_inject_4k(int drm_fd, drmModeConnector *connector, int start_n_modes)
+{
+	unsigned char *edid;
+	size_t length;
+	struct kmstest_connector_config config;
+	int ret, crtc_mask = -1;
+	int fb_id;
+	struct igt_fb fb;
+	uint32_t devid;
+	drmModeConnector *temp;
+
+	devid = intel_get_drm_devid(drm_fd);
+
+	/* 4K requires at least HSW */
+	igt_require(IS_HASWELL(devid) || IS_BROADWELL(devid));
+
+	kmstest_edid_add_4k(igt_kms_get_base_edid(), EDID_LENGTH, &edid,
+			    &length);
+
+	kmstest_force_connector(drm_fd, connector, FORCE_CONNECTOR_ON);
+	temp = drmModeGetConnectorCurrent(drm_fd, connector->connector_id);
+
+	drmModeFreeConnector(temp);
+
+	kmstest_force_edid(drm_fd, connector, edid, length);
+	temp = drmModeGetConnectorCurrent(drm_fd, connector->connector_id);
+
+	CHECK_MODE(temp->modes[1], HDISPLAY_4K, VDISPLAY_4K, 30);
+
+	/* create a configuration */
+	ret = kmstest_get_connector_config(drm_fd, temp->connector_id, crtc_mask, &config);
+	igt_assert(ret);
+
+	igt_info("  ");
+	kmstest_dump_mode(&temp->modes[1]);
+
+	/* create framebuffer */
+	fb_id = igt_create_fb(drm_fd, temp->modes[1].hdisplay,
+			      temp->modes[1].vdisplay,
+			      DRM_FORMAT_XRGB8888,
+			      LOCAL_DRM_FORMAT_MOD_NONE, &fb);
+
+	ret = drmModeSetCrtc(drm_fd, config.crtc->crtc_id, fb_id, 0, 0,
+			     &temp->connector_id, 1, &temp->modes[1]);
+
+	igt_assert(ret == 0);
+	drmModeFreeConnector(temp);
+
+	igt_remove_fb(drm_fd, &fb);
+
+	kmstest_force_edid(drm_fd, connector, NULL, 0);
+	kmstest_force_connector(drm_fd, connector, FORCE_CONNECTOR_UNSPECIFIED);
+
+	temp = drmModeGetConnectorCurrent(drm_fd, connector->connector_id);
+	igt_assert_eq(temp->count_modes, start_n_modes);
+
+	drmModeFreeConnector(temp);
+
+	free(edid);
+}
+
+
+static void
+hdmi_inject_audio(int drm_fd, drmModeConnector *connector, int start_n_modes)
+{
+	unsigned char *edid;
+	size_t length;
+	int fb_id, ret, crtc_mask = -1;
+	struct igt_fb fb;
+	struct kmstest_connector_config config;
+	drmModeConnector *temp;
+
+	kmstest_edid_add_audio(igt_kms_get_base_edid(), EDID_LENGTH, &edid,
+			       &length);
+
+	kmstest_force_connector(drm_fd, connector, FORCE_CONNECTOR_ON);
+	temp = drmModeGetConnectorCurrent(drm_fd, connector->connector_id);
+
+	drmModeFreeConnector(temp);
+
+	kmstest_force_edid(drm_fd, connector, edid, length);
+	temp = drmModeGetConnectorCurrent(drm_fd, connector->connector_id);
+
+
+	/* create a configuration */
+	ret = kmstest_get_connector_config(drm_fd, temp->connector_id, crtc_mask, &config);
+	igt_assert(ret);
+
+	/*
+	 * Create a framebuffer as to allow the kernel to enable the pipe and
+	 * enable the audio encoder.
+	 */
+	fb_id = igt_create_fb(drm_fd, temp->modes[0].hdisplay,
+			      temp->modes[0].vdisplay,
+			      DRM_FORMAT_XRGB8888,
+			      LOCAL_DRM_FORMAT_MOD_NONE, &fb);
+
+	ret = drmModeSetCrtc(drm_fd, config.crtc->crtc_id, fb_id, 0, 0,
+			     &temp->connector_id, 1, &temp->modes[0]);
+
+
+	igt_assert(ret == 0);
+
+	/*
+	 * Test if we have /proc/asound/HDMI/eld#0.0 and its contents are valid.
+	 */
+	igt_assert(eld_is_valid(AUDIO_OUTPUTS));
+
+	igt_remove_fb(drm_fd, &fb);
+	drmModeFreeConnector(temp);
+
+	kmstest_force_edid(drm_fd, connector, NULL, 0);
+	kmstest_force_connector(drm_fd, connector, FORCE_CONNECTOR_UNSPECIFIED);
+	temp = drmModeGetConnectorCurrent(drm_fd, connector->connector_id);
+	igt_assert_eq(temp->count_modes, start_n_modes);
+
+	drmModeFreeConnector(temp);
+	free(edid);
+}
+
 int main(int argc, char **argv)
 {
 	/* force the VGA output and test that it worked */
 	int drm_fd = 0;
 	drmModeRes *res;
 	drmModeConnector *vga_connector = NULL, *temp;
+	drmModeConnector *hdmi_connector = NULL;
 	int start_n_modes, start_connection;
 	struct option long_opts[] = {
 		{"reset", 0, 0, 'r'},
@@ -86,12 +272,13 @@ int main(int argc, char **argv)
 				    opt_handler, NULL);
 
 	igt_fixture {
+		int i;
 		drm_fd = drm_open_driver_master(DRIVER_INTEL);
 		res = drmModeGetResources(drm_fd);
 		igt_assert(res);
 
 		/* find the vga connector */
-		for (int i = 0; i < res->count_connectors; i++) {
+		for (i = 0; i < res->count_connectors; i++) {
 
 			vga_connector = drmModeGetConnectorCurrent(drm_fd,
 								   res->connectors[i]);
@@ -101,17 +288,31 @@ int main(int argc, char **argv)
 				start_connection = vga_connector->connection;
 				break;
 			}
-
 			drmModeFreeConnector(vga_connector);
 
 			vga_connector = NULL;
 		}
 
-		igt_require(vga_connector);
-		igt_skip_on(vga_connector->connection == DRM_MODE_CONNECTED);
+		/* find the HDMI connector */
+		for (i = 0; i < res->count_connectors; i++) {
+
+			hdmi_connector = drmModeGetConnectorCurrent(drm_fd,
+								   res->connectors[i]);
+
+			if (hdmi_connector->connector_type == DRM_MODE_CONNECTOR_HDMIA) {
+				start_n_modes = hdmi_connector->count_modes;
+				start_connection = hdmi_connector->connection;
+				break;
+			}
+			drmModeFreeConnector(hdmi_connector);
+
+			hdmi_connector = NULL;
+		}
 	}
 
 	igt_subtest("force-load-detect") {
+		igt_require(vga_connector);
+		igt_skip_on(vga_connector->connection == DRM_MODE_CONNECTED);
 		/*
 		 * disable all outputs to make sure we have a
 		 * free crtc available for load detect
@@ -136,6 +337,9 @@ int main(int argc, char **argv)
 	igt_subtest("force-connector-state") {
 		igt_display_t display;
 
+		igt_require(vga_connector);
+		igt_skip_on(vga_connector->connection == DRM_MODE_CONNECTED);
+
 		/* force the connector on and check the reported values */
 		kmstest_force_connector(drm_fd, vga_connector, FORCE_CONNECTOR_ON);
 		temp = drmModeGetConnectorCurrent(drm_fd,
@@ -169,7 +373,10 @@ int main(int argc, char **argv)
 		drmModeFreeConnector(temp);
 	}
 
-	igt_subtest("force-edid") {
+	igt_subtest("force-edid-vga") {
+		igt_require(vga_connector);
+		igt_skip_on(vga_connector->connection == DRM_MODE_CONNECTED);
+
 		kmstest_force_connector(drm_fd, vga_connector,
 					FORCE_CONNECTOR_ON);
 		temp = drmModeGetConnectorCurrent(drm_fd,
@@ -203,9 +410,28 @@ int main(int argc, char **argv)
 
 	}
 
+	igt_subtest("force-edid-hdmi-4k") {
+
+		igt_require(hdmi_connector);
+		igt_skip_on(hdmi_connector->connection == DRM_MODE_CONNECTED);
+
+		hdmi_inject_4k(drm_fd, hdmi_connector, start_n_modes);
+	}
+
+	igt_subtest("force-edid-hdmi-audio") {
+
+		igt_require(hdmi_connector);
+		igt_skip_on(hdmi_connector->connection == DRM_MODE_CONNECTED);
+
+		hdmi_inject_audio(drm_fd, hdmi_connector, start_n_modes);
+	}
+
 	igt_subtest("prune-stale-modes") {
 		int i;
 
+		igt_require(vga_connector);
+		igt_skip_on(vga_connector->connection == DRM_MODE_CONNECTED);
+
 		kmstest_force_connector(drm_fd, vga_connector,
 					FORCE_CONNECTOR_ON);
 