diff --git a/tests/gem_concurrent_all.c b/tests/gem_concurrent_all.c
index 10e5357..688eecb 100644
--- a/tests/gem_concurrent_all.c
+++ b/tests/gem_concurrent_all.c
@@ -1530,7 +1530,7 @@ run_mode(const char *prefix,
 					      p->copy, h->hang);
 			}
 
-			/* and finally try to trick the kernel into loosing the pending write */
+			/* and finally try to trick the kernel into losing the pending write */
 			igt_subtest_f("%s-%s-%s-gpu-read-after-write%s%s", prefix, mode->name, p->prefix, suffix, h->suffix) {
 				buffers_create(&buffers);
 				run_wrap_func(&buffers,
diff --git a/tests/gem_cpu_reloc.c b/tests/gem_cpu_reloc.c
index 520030a..7324c4c 100644
--- a/tests/gem_cpu_reloc.c
+++ b/tests/gem_cpu_reloc.c
@@ -232,7 +232,7 @@ static void run_test(int fd, int count)
 		igt_progress("gem_cpu_reloc: ", 2*count+i, 3*count);
 	}
 
-	igt_info("Subtest suceeded, cleanup up - this might take a while.\n");
+	igt_info("Subtest succeeded, cleanup up - this might take a while.\n");
 	for (i = 0; i < count; i++) {
 		gem_close(fd, handles[i]);
 	}
diff --git a/tests/gem_flink_race.c b/tests/gem_flink_race.c
index 30e33f6..5937bc0 100644
--- a/tests/gem_flink_race.c
+++ b/tests/gem_flink_race.c
@@ -143,7 +143,7 @@ static void test_flink_close(void)
 	void *status;
 	int fake;
 
-	/* Allocate exit handler fds in here so that we dont screw
+	/* Allocate exit handler fds in here so that we don't screw
 	 * up the counts */
 	fake = drm_open_driver(DRIVER_INTEL);
 
diff --git a/tests/gem_seqno_wrap.c b/tests/gem_seqno_wrap.c
index f6320f4..e4a6277 100644
--- a/tests/gem_seqno_wrap.c
+++ b/tests/gem_seqno_wrap.c
@@ -485,7 +485,7 @@ int main(int argc, char **argv)
 		"  -t --timeout=sec      set timeout to wait for testrun to sec seconds\n"
 		"  -d --dontwrap         don't wrap just run the test\n"
 		"  -p --prewrap=n        set seqno to WRAP - n for each testrun\n"
-		"  -r --norandom         dont randomize prewrap space\n"
+		"  -r --norandom         don't randomize prewrap space\n"
 		"  -i --buffers          number of buffers to copy\n";
 
 	options.rounds = SLOW_QUICK(50, 2);
diff --git a/tests/gem_tiled_wb.c b/tests/gem_tiled_wb.c
index 67d54bd..2919736 100644
--- a/tests/gem_tiled_wb.c
+++ b/tests/gem_tiled_wb.c
@@ -68,7 +68,7 @@ create_bo(int fd)
 	handle = gem_create(fd, SIZE);
 	gem_set_tiling(fd, handle, I915_TILING_X, WIDTH * sizeof(uint32_t));
 
-	/* Write throught the fence to tiled the data.
+	/* Write through the fence to tile the data.
 	 * We then manually detile on reading back through the mmap(wc).
 	 */
 	data = gem_mmap__gtt(fd, handle, SIZE, PROT_READ | PROT_WRITE);
diff --git a/tests/prime_nv_api.c b/tests/prime_nv_api.c
index 054a1ec..6bf891a 100644
--- a/tests/prime_nv_api.c
+++ b/tests/prime_nv_api.c
@@ -1,4 +1,4 @@
-/* wierd use of API tests */
+/* weird use of API tests */
 
 /* test1- export buffer from intel, import same fd twice into nouveau,
    check handles match
diff --git a/tests/prime_nv_pcopy.c b/tests/prime_nv_pcopy.c
index b5ceabf..99eaeea 100644
--- a/tests/prime_nv_pcopy.c
+++ b/tests/prime_nv_pcopy.c
@@ -673,7 +673,7 @@ static void check3(const uint32_t *p, uint32_t pitch, uint32_t lines,
 	}
 }
 
-/* copy from nvidia bo to intel bo and copy to a linear bo to check if tiling went succesful */
+/* copy from nvidia bo to intel bo and copy to a linear bo to check if tiling went successful */
 static void test3_base(int tile_src, int tile_dst)
 {
 	struct nouveau_bo *bo_intel = NULL, *bo_nvidia = NULL, *bo_linear = NULL;
diff --git a/tests/prime_self_import.c b/tests/prime_self_import.c
index 992334d..5ec0baa 100644
--- a/tests/prime_self_import.c
+++ b/tests/prime_self_import.c
@@ -239,7 +239,7 @@ static void test_reimport_close_race(void)
 	uint32_t handle;
 	int fake;
 
-	/* Allocate exit handler fds in here so that we dont screw
+	/* Allocate exit handler fds in here so that we don't screw
 	 * up the counts */
 	fake = drm_open_driver(DRIVER_INTEL);
 
@@ -329,7 +329,7 @@ static void test_export_close_race(void)
 
 	threads = calloc(num_threads, sizeof(pthread_t));
 
-	/* Allocate exit handler fds in here so that we dont screw
+	/* Allocate exit handler fds in here so that we don't screw
 	 * up the counts */
 	fake = drm_open_driver(DRIVER_INTEL);
 